"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var table_results_page_1 = require("../table-results-page");
var footer_legend_1 = require("./footer-legend");
var PAGES_LIMIT = 6;
var FooterComponent = (function () {
    function FooterComponent() {
        this.onPageClicked = new core_1.EventEmitter();
    }
    FooterComponent.prototype.ngOnInit = function () {
    };
    FooterComponent.prototype.getPageBeginning = function () {
        return this.resultsPage.from + 1;
    };
    FooterComponent.prototype.getPageEnd = function () {
        return Math.min(this.resultsPage.from + this.resultsPage.count, this.resultsPage.total);
    };
    FooterComponent.prototype.getTotal = function () {
        return this.resultsPage.total;
    };
    FooterComponent.prototype.getPages = function () {
        var pages = [];
        var radio = PAGES_LIMIT / 2;
        var currentPage = this.currentPage;
        var totalPages = this.getTotalPages();
        var firstPage;
        var lastPage;
        if (totalPages - currentPage <= radio) {
            firstPage = Math.max(0, totalPages - PAGES_LIMIT);
            lastPage = totalPages;
        }
        else if (currentPage <= radio) {
            firstPage = 0;
            lastPage = Math.min(totalPages, PAGES_LIMIT);
        }
        else {
            firstPage = currentPage - radio;
            lastPage = currentPage + radio;
        }
        for (var i = firstPage; i < lastPage; i++) {
            pages.push(i + 1);
        }
        return pages;
    };
    FooterComponent.prototype.getTotalPages = function () {
        return Math.ceil((this.getTotal() / this.resultsPage.count));
    };
    FooterComponent.prototype.isFirstPageVisible = function () {
        var currentPage = this.getCurrentPage();
        return currentPage > PAGES_LIMIT / 2 && this.getTotalPages() > PAGES_LIMIT;
    };
    FooterComponent.prototype.isLastPageVisible = function () {
        var totalPages = this.getTotalPages();
        return totalPages - this.currentPage > PAGES_LIMIT / 2 && totalPages > PAGES_LIMIT;
    };
    FooterComponent.prototype.pageClicked = function (page) {
        this.currentPage = page - 1;
        this.onPageClicked.emit(page - 1);
    };
    FooterComponent.prototype.onFirstClicked = function () {
        this.currentPage = 0;
        this.onPageClicked.emit(this.currentPage);
    };
    FooterComponent.prototype.onLastClicked = function () {
        this.currentPage = this.getTotalPages() - 1;
        this.onPageClicked.emit(this.currentPage);
    };
    FooterComponent.prototype.getCurrentPage = function () {
        return this.currentPage;
    };
    return FooterComponent;
}());
__decorate([
    core_1.Input(),
    __metadata("design:type", table_results_page_1.TableResultsPage)
], FooterComponent.prototype, "resultsPage", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], FooterComponent.prototype, "onPageClicked", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", footer_legend_1.FooterLegend)
], FooterComponent.prototype, "footerLegend", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Object)
], FooterComponent.prototype, "currentPage", void 0);
FooterComponent = __decorate([
    core_1.Component({
        selector: 'ngx-iq-footer',
        templateUrl: './footer.component.html',
        styleUrls: ['./footer.component.css']
    }),
    __metadata("design:paramtypes", [])
], FooterComponent);
exports.FooterComponent = FooterComponent;
//# sourceMappingURL=footer.component.js.map